/*
 * ConnectionIcon.java
 *
 * Created on 23 lipiec 2001, 20:55
 */

/**
 *
 * @author  k
 */
import java.awt.*;
import java.awt.Graphics2D.*;
import javax.swing.*;
import java.util.*;
  

  public class ConnectionIcon extends JComponent
    {
        Image obraz;
        Graphics2D graphics2D;
        public int num;
        public Point a = new Point(0,0);
        public Point b = new Point(0,0);
        public String sWeight="";
        
                Network net;
        NeuralNetEditor ed;
        
        public ConnectionIcon(Point a, Point b)
        {
            sWeight = "";
            setDoubleBuffered(false);
            this.setOpaque(true);
            this.setSize(new Dimension(15,15));     
            this.a = a;
            this.b = b;
        }
        public Point GetCenterPoint()
        {
            return new Point(((int)((a.x+b.x)/2)),((int)((a.y+b.y)/2)));
        }
        
        public void SetWeight(double w)
        {
            sWeight = String.valueOf(w);
            if (sWeight.length() > 6)
            {
                sWeight = sWeight.substring(0,5);
            }
        }
        public void SetNetwork(Network n)
        {
            this.net = n;
        }
        public void SetEditor(NeuralNetEditor ed)
        {
            this.ed = ed;
        }
        
        
        public void paintComponent(Graphics g)
        {
            System.out.println("ConnectionIcon.paintComponent() fired !");
        /*    if (obraz == null)
            {
                obraz = createImage(this.getWidth(), this.getHeight());
                /*System.out.println("obraz==null, ");
                System.out.println(this.getWidth());
                System.out.println(this.getHeight());*/
               /*     graphics2D = (Graphics2D) obraz.getGraphics();
                graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
                    RenderingHints.VALUE_ANTIALIAS_ON);
                czysc();
            }*/
          //  g.setColor(Color.white);
           // g.fillRect(this.getLocation().x, this.getLocation().y, 15, 15);
            g.setColor(Color.BLACK);
            g.drawLine(a.x, a.y, b.x, b.y);
            
            if (ed.network.Wires[num].getOptimize())
            {
                g.drawString("[ "+sWeight+" ] Opt", this.GetCenterPoint().x-5, this.GetCenterPoint().y-5);
            }
            else
            {
                g.drawString("[ "+sWeight+" ]", this.GetCenterPoint().x-5, this.GetCenterPoint().y-5);
            }
            g.setColor(Color.RED);
            g.drawRect(this.getLocation().x, this.getLocation().y, 15, 15);
        }
        public void czysc()
        {
            /*graphics2D.setPaint(Color.blue);
            graphics2D.fillRect(0,  0,  this.getSize().width, this.getSize().height);
            System.out.println("czysc() fired!");
            System.out.println(getSize().width);
            graphics2D.setPaint(Color.black);*/
            repaint();
        }
    }


