/*
 * NeuronIcon.java
 *
 * Created on 23 lipiec 2001, 20:55
 */

/**
 *
 * @author  k
 */
import java.awt.*;
import java.awt.Graphics2D.*;
import javax.swing.*;
import java.util.*;
  

  public class NeuronIcon extends JComponent
    {
        Image obraz;
        Graphics2D graphics2D;
        public int num;
        public String Name="";
        public String Number="";
        Network net;
        NeuralNetEditor ed;
        public NeuronIcon()
        {
            Name = "";
            setDoubleBuffered(false);
            this.setOpaque(true);
            this.setSize(new Dimension(40,40));           
        }
        
        public void SetNetwork(Network n)
        {
            this.net = n;
        }
        public void SetEditor(NeuralNetEditor ed)
        {
            this.ed = ed;
        }
        
        public void SetName(String s)
        {
            Name = s;
        }
        public void SetNumber(int n)
        {
            Number = String.valueOf(n);
        }
        
        
        public void paintComponent(Graphics g)
        {
            System.out.println("NeuronIcon.paintComponent() fired !");
        /*    if (obraz == null)
            {
                obraz = createImage(this.getWidth(), this.getHeight());
                /*System.out.println("obraz==null, ");
                System.out.println(this.getWidth());
                System.out.println(this.getHeight());*/
               /*     graphics2D = (Graphics2D) obraz.getGraphics();
                graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
                    RenderingHints.VALUE_ANTIALIAS_ON);
                czysc();
            }*/
            System.out.println(this.getLocation());
            System.out.println(this.getX());
            int []  polyx = new int[4];
            int []  polyy = new int[4];
            polyx[0] = this.getLocation().x;
            polyx[1] = this.getLocation().x;
            polyx[2] = this.getLocation().x+40;
            polyx[3] = this.getLocation().x;
            polyy[0] = this.getLocation().y;
            polyy[1] = this.getLocation().y+40;
            polyy[2] = this.getLocation().y+20;
            polyy[3] = this.getLocation().y;        
            //g.setColor(Color.white);
            //g.drawRect(this.getLocation().x, this.getLocation().y, 15, 15);          
            //g.setColor(Color.white);
            //g.fillRect(this.getLocation().x, this.getLocation().y, 40, 40);
            g.setColor(Color.blue);
            g.drawPolygon(polyx, polyy, 4);
            if (ed.network.Neurons[num].getOptimize())
            { 
               g.drawString(Name+" ("+Number+")"+" Opt", this.getLocation().x+2, this.getLocation().y+23);
            }
            else
            {
               g.drawString(Name+" ("+Number+")", this.getLocation().x+2, this.getLocation().y+23);
            }
            g.setColor(Color.BLACK);
            g.drawLine(this.getLocation().x+40,this.getLocation().y+20,this.getLocation().x+50,this.getLocation().y+20);
            g.drawLine(this.getLocation().x-10,this.getLocation().y+20,this.getLocation().x,this.getLocation().y+20);
        }
        public void czysc()
        {
            /*graphics2D.setPaint(Color.blue);
            graphics2D.fillRect(0,  0,  this.getSize().width, this.getSize().height);
            System.out.println("czysc() fired!");
            System.out.println(getSize().width);
            graphics2D.setPaint(Color.black);*/
            repaint();
        }
    }

