
/*
 * SinNeuron.java
 *
 * Created on 16 lipiec 2001, 16:04
 */

/**
 *
 * @author  k
 */
public class SinNeuron extends Neuron {
    
    public double f0 = 0;
    public double t = 0;
    public String Name="Sin";
    
    public SinNeuron(double f0, double t) {
        waveDisplay = new WaveformWindow();
        waveDisplay.SetNeuronName(Name);
        this.f0 = f0;
        this.t = t;
    }
    
    public SinNeuron(double f0, double t, WaveformWindow waveDisplay) {
       //waveDisplay = new WaveformWindow();
        //waveDisplay.SetNeuronName(Name);
        this.waveDisplay = waveDisplay;
        this.f0 = f0;
        this.t = t;
    }
    
    
    public void AddRandom()
    {
        java.util.Random rnd = new java.util.Random(System.currentTimeMillis());
        this.f0 += 0.1 - 0.2*rnd.nextDouble();
        this.t += 0.1 - 0.2*rnd.nextDouble();
    }
    
    double Evaluate() {
        double input = activation();
        t = t + f0 + input;
        Output = Math.sin(t); 
        return Output;
    }  
}
