/*
 * EditSquare.java
 *
 * Created on 23 lipiec 2001, 16:25
 */

/**
 *
 * @author  k
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.Graphics2D.*;
import javax.swing.*;
import java.util.*;
  

  public class WaveArea extends JComponent
    {
        Image obraz;
        Graphics2D graphics2D;
        
        public NeuronIcon neuronIcon = null;
        public NeuralNetEditor ed = null;
        public WaveformWindow ww = null;
  
        private int stare_x;
        private int stare_y;
        private int aktualne_x;
        private int aktualne_y;
        private int aktualny_punkt;
        
        private double x_min;
        private double x_max;
        private double y_min;
        private double y_max;
        
       // public Container zawartosc;
       // public EditSquareBackground editSquareBackground;
        
        public void setNeuronIcons()
        {
            /*this.removeAll();
            for (int i=0; i<c.Points.length; i++)
            {
                NeuronIcon ed = new NeuronIcon();
                this.add(ed);
                ed.num = i;
                ed.setLocation(this.getPixelX(c.Points[i]), this.getPixelY(c.Points[i]));                
            }*/
        }
        
        public void setWaveformWindow(WaveformWindow ww)
        {
            this.ww = ww;
        }
        public void setNeuralNetEditor(NeuralNetEditor ed)
        {
            this.ed = ed;
        }
        
        public int getPixelX(MhPoint p)
        {  
            if ((p.GetX()>=x_min)&&(p.GetX()<=x_max))
            {
                double answer;
                answer = ((double)this.getWidth());
                answer *=(((double)p.GetX())-x_min)/(x_max-x_min);
                return (int)answer;
            }
            else
            {
                return -1; //punkt na pewno poza obszarem wyswietlania
            }
        }
        
        public void setMinY(double y)
        {
            this.y_min = y;
        }
        public void setMinX(double x)
        {
            this.x_min = x;
        }
        public void setMaxY(double y)
        {
            this.y_max = y;
        }
        public void setMaxX(double x)
        {
            this.x_max = x;
        }
         
        public int getPixelY(MhPoint p)
        {           
            if ((p.GetY()>=y_min)&&(p.GetY()<=y_max))
            {
                double answer;
                answer = ((double)this.getHeight());
                answer *=(((double)p.GetY())-y_min)/(y_max-y_min);
                return this.getHeight()-(int)answer;
            }
            else
            {
                return -1; //punkt na pewno poza obszarem wyswietlania
            }
        }
        
        public WaveArea(){
            //super();
            setDoubleBuffered(false);
            this.setMinimumSize(new Dimension(100, 100));
           // this.setSize(d);
            this.setLayout(null);
            this.setBackground(Color.WHITE);
            this.aktualny_punkt = -1;
            
           // editSquareBackground = new EditSquareBackground(d);
          //  editSquareBackground.setSize(d);
          //  NeuronIcon = new NeuronIcon();
           // this.NeuronIcon.setLocation(20,20);
           // this.add(NeuronIcon);
                      
           // this.NeuronIcon.setVisible(true);
           // this.add(editSquareBackground);
            
         //   editSquareBackground.setSize(d);
            
            //System.out.println("EditArea() fired!");
            //System.out.println(d);
            //System.out.println(this.getSize());      
           // System.out.println(this.editSquareBackground.getSize());      

            addMouseListener(new MouseAdapter(){
               public void mousePressed(MouseEvent e){
                   if (e.getButton()==e.BUTTON1)
                   {
                        stare_x = e.getX();
                        stare_y = e.getY();       
                        System.out.println(stare_x);
                        System.out.println(stare_y);
                        int i = stare_x/ww.zoom;
                        
                        double val = (ww.waveArea.getHeight()/2.0-stare_y)/(ww.waveArea.getHeight()/2.0);
                        if (i<ww.nSamples)
                        {
                            ww.TargetWaveform[i] = val;
                        }
                       // System.out.println("i = "+i);
                    //    System.out.println("val = "+val);
                   }
                   else
                   {
                       System.out.println("RightClick!");
                       stare_x = e.getX();
                       stare_y = e.getY();   
                   }
                   repaint();
              }
            });
            addMouseMotionListener(new MouseMotionAdapter(){
                    public void mouseDragged(MouseEvent e){
                        aktualne_x = e.getX();
                        aktualne_y = e.getY();

                        
                        
                        
                        if (aktualne_x < 0)
                        {
                            aktualne_x = 0;
                        }
                        if (aktualne_y < 0)
                        {
                            aktualne_y = 0;
                        }
                        /*
                        if (graphics2D != null)
                        {
                            graphics2D.drawLine(stare_x, stare_y, aktualne_x,  aktualne_y);
                        }                       
                        */
                        // #######  TUTAJ INTERPOLACJA LINIOWA !!!!!!!!!!!!
                        
                        int ile = Math.abs(stare_x-aktualne_x)/ww.zoom;
                        double dx = (aktualne_x-stare_x)/ww.zoom;
                        if (ile==0) 
                        {
                            ile = 1;
                        }
                        
                        int fromSample = stare_x/ww.zoom;
                        int toSample = aktualne_x/ww.zoom;
                      /*  int dir = 1;
                        if (toSample<fromSample)
                        {
                            int tmp = toSample;
                            toSample = fromSample;
                            fromSample = tmp;
                            dir = -1;
                        }*/
                     /*   for (int k=0; k<ile; k++)
                        {
                            int i = k/ile;
                        }*/ 
                        if ((fromSample>=0)&&(fromSample<ww.nSamples)&&(toSample>=0)&&(toSample<ww.nSamples))
                        {                            
                            double current_y;
                            if (fromSample - toSample == 0)
                            {
                                double val = (ww.waveArea.getHeight()/2.0-aktualne_y)/(ww.waveArea.getHeight()/2.0);
                                if (toSample<ww.nSamples)
                                {
                                    ww.TargetWaveform[toSample] = val;
                                }
                            }
                            else if (Math.abs(fromSample - toSample) == 1)
                            {
                                double val = (ww.waveArea.getHeight()/2.0-aktualne_y)/(ww.waveArea.getHeight()/2.0);
                                if (toSample<ww.nSamples)
                                {
                                    ww.TargetWaveform[toSample] = val;
                                }
                            }
                            else
                            {
                                if (toSample<fromSample)
                                {
                                    int tmp = toSample;
                                    toSample = fromSample;
                                    fromSample = tmp;
                                  // dir = -1;
                                }
                                for (int i=fromSample; i<=toSample; i++)
                                {
                                    current_y = (double)stare_y - ((stare_y - aktualne_y)*(i-fromSample))/(dx);
                                    double val = (ww.waveArea.getHeight()/2.0-current_y)/(ww.waveArea.getHeight()/2.0);
                                    if (val>1)
                                    {
                                        val = 1;
                                    }
                                    if (val<-1)
                                    {
                                        val = -1;
                                    }
                                    if (i<ww.nSamples)
                                    {
                                        ww.TargetWaveform[i] = val;
                                    }
                                }
                            }
                            /*
                            double val = (ww.waveArea.getHeight()/2.0-stare_y)/(ww.waveArea.getHeight()/2.0);
                            ww.TargetWaveForm[fromSample] = val;
                            double val = (ww.waveArea.getHeight()/2.0-aktualne_y)/(ww.waveArea.getHeight()/2.0);
                            ww.TargetWaveForm[toSample] = val;
                             **/
                        }
                        
                        stare_x = aktualne_x;
                        stare_y = aktualne_y;
                        System.out.println("MouseDragged");
                        repaint();
                    }
            });
        }        
        public void paintComponent(Graphics g)
        {
            System.out.println("WaveArea: paintComponent() fired !");
            //if (obraz == null)
            //{
                obraz = createImage(this.getWidth(), this.getHeight());
                System.out.println(this.getWidth());
                System.out.println(this.getHeight());
                    graphics2D = (Graphics2D) obraz.getGraphics();
                graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
                    RenderingHints.VALUE_ANTIALIAS_OFF);
                //czysc();
            //}       
            //g.drawImage(obraz, 0, 0, 100, 100, null); 
           graphics2D.setBackground(Color.WHITE);
           graphics2D.clearRect(0, 0, this.getWidth(), this.getHeight());
           graphics2D.setColor(Color.GRAY);
           graphics2D.drawLine(0, (int)(this.getHeight()/2.0), this.getWidth()-1, (int)(this.getHeight()/2.0));
           graphics2D.setColor(Color.BLUE);
           for (int i=0; i<ww.nSamples-1; i++)
           {
            graphics2D.drawLine(ww.zoom*i,(int)(this.getHeight()/2.0+(this.getHeight()/2.0)*(-ww.ActualWaveform[i])), ww.zoom*i+ww.zoom, (int)(this.getHeight()/2.0+(this.getHeight()/2.0)*(-ww.ActualWaveform[i+1])));
           }
           graphics2D.setColor(Color.RED);
           for (int i=0; i<ww.nSamples-1; i++)
           {
            graphics2D.drawLine(ww.zoom*i,(int)(this.getHeight()/2.0+(this.getHeight()/2.0)*(-ww.TargetWaveform[i])), ww.zoom*i+ww.zoom, (int)(this.getHeight()/2.0+(this.getHeight()/2.0)*(-ww.TargetWaveform[i+1])));
           }
           g.drawImage(obraz, 0, 0, null);
            /*int i = this.getComponentCount()-1;
            for (; i>=0; i--)
            {
                Component c = this.getComponent(i);
                c.paint(g);
            }*/
        }
        public void czysc()
        {
            graphics2D.setPaint(Color.white);
            graphics2D.fillRect(0,  0,  getSize().width, getSize().height);
          //  System.out.println("Square : czysc() fired!");
          //  System.out.println(getSize().width);
            graphics2D.setPaint(Color.black);
            repaint();
        }
    }

